(defun load-png-image (source-file)
  (sdl:convert-to-display-format :surface (sdl:load-image source-file)
                                 :enable-alpha t
                                 :pixel-alpha t))

(defun main ()
  (sdl:with-init ()
    (sdl:window 640 480 :title-caption "てすと")
    (setf (sdl:frame-rate) 60)
    (sdl:initialise-default-font sdl:*font-10x20*) ; フォント初期化
    (let ((img (load-png-image "test.png"))) ; 画像ファイルをロード

      (sdl:update-display)

      (sdl:with-events ()
        (:quit-event () t)
        (:key-down-event (:key key)
          (when (sdl:key= key :sdl-key-escape)
            (sdl:push-quit-event)))
        (:idle ()
          ;; 描画する前に前に書いたものを消します
          (sdl:clear-display sdl:*black*)
          ;; 四角形を描画
          (sdl:draw-box-* 10 ; 左上頂点のX座標
                          20 ; 左上頂点のY座標
                          30 ; 幅
                          40 ; 高さ
                          :color sdl:*magenta* ; 中の色
                          :stroke-color sdl:*white*) ; 辺の色
          ;; 円を描画
          (sdl:draw-filled-circle-* 100 ; 中心のX座標
                                    200 ; 中心のY座標
                                    30  ; 半径
                                    :color sdl:*red*) ; 中の色
          ;; 画像描画
          (sdl:draw-surface-at-* img  ; 画像
                                 200  ; 左上頂点のX座標
                                 100) ; 左上頂点のY座標
          ;; 文字列描画
          (sdl:draw-string-solid-* ;; FPSを取得して文字列に変換
                                   (format nil "~,2F" (sdl:average-fps))
                                   300  ; 左上頂点のX座標
                                   400) ; 左上頂点のY座標
          (sdl:update-display))))))
