;; 総称関数
(defgeneric update-enemy (enemy)
  (:documentation "敵の状態を更新する"))
(defgeneric draw-enemy (enemy game-field)
  (:documentation "敵を描画する"))
(defgeneric out-of-field-p (enemy game-field)
  (:documentation "敵が画面外にいるかどうか判定"))

;; 敵クラス
(defclass enemy ()
  ((x
    :initarg :x
    :initform 0
    :documentation "中心X座標")
   (y
    :initarg :y
    :initform 0
    :documentation "中心Y座標")
   (vx
    :initarg :vx
    :initform 0
    :documentation "X方向速度")
   (vy
    :initarg :vy
    :initform 0
    :documentation "Y方向速度")
   (width
    :initarg :width
    :initform 128
    :documentation "幅")
   (height
    :initarg :height
    :initform 128
    :documentation "高さ")
   (image
    :initarg :image
    :initform (error "敵画像ファイルを指定しろ")
    :documentation "画像")))

(defmethod update-enemy ((enemy enemy))
  (with-slots (x y vx vy) enemy
    (incf x vx)
    (incf y vy)))

(defmethod draw-enemy ((enemy enemy) (game-field game-field))
  (with-slots (x y width height image) enemy
    (sdl:draw-surface-at-* image
                           (round (+ (game-field-x game-field)
                                     (- x (/ width 2))))
                           (round (+ (game-field-y game-field)
                                     (- y (/ height 2)))))))

(defmethod out-of-field-p ((enemy enemy) (game-field game-field))
  (with-slots (x y width height) enemy
    (let ((width/2 (/ width 2))
          (height/2 (/ height 2)))
      (or (< (+ x width/2) 0)
          (< (+ y height/2) 0)
          (> (- x width/2) (game-field-width game-field))
          (> (- y height/2) (game-field-height game-field))))))
