(defgeneric hit-test (region-1 region-2)
  (:documentation "当たり判定を行う"))

;; 当たり判定クラス。すべての当たり判定はこのクラスを継承して欲しい
(defclass hit-test-region ()
  ())

;; 円形当たり判定クラス
(defclass circle-region (hit-test-region)
  ((x
    :initarg :x
    :initform 0
    :accessor circle-x
    :documentation "中心X座標")
   (y
    :initarg :y
    :initform 0
    :accessor circle-y
    :documentation "中心Y座標")
   (r
    :initarg :r
    :initform 0
    :accessor circle-radius
    :documentation "半径")))

;; 円形対円形の当たり判定クラス
(defmethod hit-test ((region-1 circle-region) (region-2 circle-region))
  (let ((dx (- (circle-x region-1) (circle-x region-2)))
        (dy (- (circle-y region-1) (circle-y region-2)))
        (rs (+ (circle-radius region-1) (circle-radius region-2))))
    (<= (+ (* dx dx) (* dy dy))
        (* rs rs))))
