(defgeneric add-image (image-loader key image-file)
  (:documentation "ロードする画像を登録する"))
(defgeneric get-image (image-loader key)
  (:documentation "ロードした画像を取得する"))

(defclass image-loader ()
  ((images
    :initform nil
    :documentation "ロードした画像")))

(defun load-png-image (source-file)
  (sdl:convert-to-display-format :surface (sdl:load-image source-file)
                                 :enable-alpha t
                                 :pixel-alpha t))

(defmethod add-image ((image-loader image-loader) key image-file)
  (with-slots (images) image-loader
    (if (getf images key)
      (error "keyが重複してます。~a" key)
      (setf (getf images key)
            (load-png-image image-file)))))

(defmethod get-image ((image-loader image-loader) key)
  (with-slots (images) image-loader
    (getf images key)))
